Index: init/init.c
===================================================================
--- init/init.c	(revision c9857c6049423e28c75585d50f395e3aa0da24d3)
+++ init/init.c	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
@@ -34,4 +34,5 @@
 #include <ns.h>
 #include <thread.h>
+#include <task.h>
 #include <psthread.h>
 #include <futex.h>
@@ -289,4 +290,6 @@
 //	test_slam();
 	
+	printf("Userspace task, taskid=%llX\n", get_task_id());
+
 	futex_initialize(&ftx, 1);
 	if (futex_down(&ftx) < 0)
Index: libc/Makefile
===================================================================
--- libc/Makefile	(revision c9857c6049423e28c75585d50f395e3aa0da24d3)
+++ libc/Makefile	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
@@ -47,4 +47,5 @@
 	generic/string.c \
 	generic/thread.c \
+	generic/task.c \
 	generic/futex.c \
 	generic/io/io.c \
Index: libc/arch/ia64/include/psthread.h
===================================================================
--- libc/arch/ia64/include/psthread.h	(revision c9857c6049423e28c75585d50f395e3aa0da24d3)
+++ libc/arch/ia64/include/psthread.h	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
@@ -43,6 +43,6 @@
 
 #define PSTHREAD_INITIAL_STACK_PAGES_NO 2
-#define PSTHREAD_INITIAL_STACK_DIVISION 2  /*Stack is divided into two equal parts (for clasic stack and register stack)*/
-
+/* Stack is divided into two equal parts (for memory stack and register stack). */
+#define PSTHREAD_INITIAL_STACK_DIVISION 2  
 
 #ifdef context_set
Index: libc/generic/task.c
===================================================================
--- libc/generic/task.c	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
+++ libc/generic/task.c	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
@@ -0,0 +1,39 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */ 
+
+#include <task.h>
+#include <libc.h>
+
+task_id_t get_task_id(void)
+{
+	task_id_t task_id;
+
+	(void) __SYSCALL1(SYS_GET_TASK_ID, (sysarg_t) &task_id);
+
+	return task_id;
+}
Index: libc/include/task.h
===================================================================
--- libc/include/task.h	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
+++ libc/include/task.h	(revision f30e6a0b867229512853621ef5b0c6e145c02572)
@@ -0,0 +1,38 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef __LIBC__TASK_H__
+#define __LIBC__TASK_H__
+
+#include <types.h>
+
+typedef uint64_t task_id_t;
+
+extern task_id_t get_task_id(void);
+
+#endif
